/*
 * GFCP_WS_Client.cpp
 *
 * main.cpp
 *
 *  Created on: May 31, 2011
 *      Author: yep
 */

#include "GFCP_WS_Client.h"
#include "GFCP_PortBinding.nsmap"
//#include "../../Includes/base64.h"
#include <sstream>
#include <iostream>

using namespace std;

GFCP_WS_Client::GFCP_WS_Client(string server, short int port, string sufix)
{
  stringstream endpointURLstream;
  endpointURLstream << "http://" << server << ":" << port << "/" << sufix;
  endpointURL = endpointURLstream.str();
  cout << "Endpoint: " << endpointURL << std::endl;

  proxy = new GFCP_PortBindingProxy(SOAP_XML_INDENT);
  proxy->soap_endpoint = endpointURL.c_str();

  startQueueProcessingThread();
} // basic constructor


GFCP_WS_Client::GFCP_WS_Client(string server, short int port)
{
  stringstream endpointURLstream;
  endpointURLstream << "http://" << server << ":" << port;
  endpointURL = endpointURLstream.str();
  cout << "Endpoint: " << endpointURL << std::endl;

  proxy = new GFCP_PortBindingProxy(SOAP_XML_INDENT);
  proxy->soap_endpoint = endpointURL.c_str();

  startQueueProcessingThread();
} // basic constructor


GFCP_WS_Client::~GFCP_WS_Client()
{
  egressSOAPQ.push(NULL);
  //wait for processing thread to stop
  pthread_join(threadPtr, NULL);

  LFB_structure *lfb = NULL;
  while (!egressSOAPQ.empty())
  {
    egressSOAPQ.try_pop(lfb);
    if (lfb != NULL)
    {
      delete lfb;
    }
  }
  delete proxy;
}

int GFCP_WS_Client::sendFrameToCE(Frame *frm)
{
//  ns1__dataRequest req;
//  ns1__basicResponse res;



 //  req->gfcpSrc = src;
 //  req->gfcpDst = dst;
 //  req->transactionID = transactionID;
 //  req->transactionType = transactionType;
 //  req->data = data;
 //  req->resulType = resultType;
 //  req->description = description;

//   string server("localhost:8000");
//   vector<char> GFCPDst(server.size() + 1);
//   copy(server.begin(), server.end(), GFCPDst.begin());
//
//   vector<char> GFCPMessageID(lfb->transactionID.size() + 1);
//   copy(lfb->transactionID.begin(), lfb->transactionID.end(), GFCPMessageID.begin());
//
//   vector<char> GFCPSrc(lfb->src.size() + 1);
//   copy(lfb->src.begin(), lfb->src.end(), GFCPSrc.begin());
//
//    char *encodedFrame = base64(frm->frame,frm->length);

//   string dataStr("test");
//   vector<char> data(dataStr.size() + 1);
//   copy(dataStr.begin(), dataStr.end(), data.begin());
//
//
//   req.GFCPDst = &GFCPDst[0];
//   req.GFCPMessageID = &GFCPMessageID[0];
//   req.GFCPSrc = &GFCPSrc[0];
//   req.data = &data[0];
//   req.data = &encodedFrame[0];

//   proxy->soap_endpoint = req.GFCPDst;
//   proxy->frameRequest(&req, &res);
//   delete [] encodedFrame;
//   cout << "\nGFCP_Client:Sending unknown frame to controller\n";
 //  cout << "Tx: " << proxy->error << " Rx: " << res.resultType_ << std::endl;
   //            cout<<"transactionID: "<<req->transactionID
   //                    <<", type:"<<req->transactionType<<endl
   //                    <<"file:"<<(req->data)<<endl<<endl;

   //    std::cout << "Sum = good"<<res  << std::endl;
   //    GFCP_WS.soap_stream_fault(std::cerr);

//   return proxy->error; // nonzero when error
   return 0;
}

int GFCP_WS_Client::loadLFB(LFB_structure *lfb)
{
  ns1__dataRequest req;
  ns1__basicResponse res;

//  req->gfcpSrc = src;
//  req->gfcpDst = dst;
//  req->transactionID = transactionID;
//  req->transactionType = transactionType;
//  req->data = data;
//  req->resulType = resultType;
//  req->description = description;

  vector<char> GFCPDst(lfb->dst.size() + 1);
  copy(lfb->dst.begin(), lfb->dst.end(), GFCPDst.begin());

  vector<char> GFCPMessageID(lfb->transactionID.size() + 1);
  copy(lfb->transactionID.begin(), lfb->transactionID.end(), GFCPMessageID.begin());

  vector<char> GFCPSrc(lfb->src.size() + 1);
  copy(lfb->src.begin(), lfb->src.end(), GFCPSrc.begin());

  vector<char> data(lfb->xml.size() + 1);
  copy(lfb->xml.begin(), lfb->xml.end(), data.begin());

  req.GFCPDst = &GFCPDst[0];
  req.GFCPMessageID = &GFCPMessageID[0];
  req.GFCPSrc = &GFCPSrc[0];
  req.data = &data[0];

  proxy->soap_endpoint = req.GFCPDst;
  proxy->controlRequest(&req, &res);

  cout << "\nGFCP_Client:Load LFB response Initiated\n";
//  cout << "Tx: " << proxy->error << " Rx: " << res.resultType_ << std::endl;
  //		cout<<"transactionID: "<<req->transactionID
  //			<<", type:"<<req->transactionType<<endl
  //			<<"file:"<<(req->data)<<endl<<endl;

  //	std::cout << "Sum = good"<<res  << std::endl;
  //	GFCP_WS.soap_stream_fault(std::cerr);

  return proxy->error; // nonzero when error
} // loadLFB


/****************************************************************************/
//! Starts a new queue processing thread.
/*! Starts a new queue processing thread, to serve the XMLs queue.
 */
/****************************************************************************/
void GFCP_WS_Client::startQueueProcessingThread()
{
  threadPtr = 0;
  if (pthread_create(&threadPtr, NULL, processQueue, (void *)this))
    throw GFEexception("Failed to start new GFCP_WS_Client thread.");
}

/****************************************************************************/
//! Processing thread function, to serve the XMLs queue.
/*! Processing thread function, to serve the XMLs queue. This thread is
 * terminated by adding a NULL frame to queue.
 *
 * @param _xml_handler - an LLRE object.
 */
/****************************************************************************/
void *GFCP_WS_Client::processQueue(void *_wsClient)
{
  GFCP_WS_Client *wsClient = (GFCP_WS_Client *)_wsClient;
  LFB_structure *lfb = NULL;
  bool processFlag = true;
  while (processFlag)
  {
    wsClient->egressSOAPQ.wait_and_pop(lfb);

    if (lfb != NULL)
    {

//      wsClient->loadLFB(lfb);
      wsClient->sendFrameToCE(NULL);

      delete lfb;
    }
    else
      processFlag = false;
  }
  pthread_exit(0);
  return 0;
}

/****************************************************************************/
//! Adds a new LFB to the processing queue.
/*! Adds a new LFB to the processing queue. This queue is used to pass
 * LFB between the protocol agent and the XML Handler, for thread safety.
 *
 * @param LFB - new LFB to process.
 */
/****************************************************************************/
void GFCP_WS_Client::pushLFBToQueue(LFB_structure *lfbStruct)
{
  egressSOAPQ.push(lfbStruct);
}
