/* soapGFCP_PortBindingService.h
   Generated by gSOAP 2.8.2 from _gfcp_fe_service
   Copyright(C) 2000-2011, Robert van Engelen, Genivia Inc. All Rights Reserved.
   The generated code is released under one of the following licenses:
   GPL OR Genivia's license for commercial use.
 */

#ifndef soapGFCP_PortBindingService_H
#define soapGFCP_PortBindingService_H
#include "soapH.h"

class XML_Handler;
//class GFCP_WS_Client;

class SOAP_CMAC GFCP_PortBindingService : public soap
{ public:
  /// Constructor
  GFCP_PortBindingService();
  /// Constructor with copy of another engine state
  GFCP_PortBindingService(const struct soap&);
  /// Constructor with engine input+output mode control
  GFCP_PortBindingService(soap_mode iomode);
  /// Constructor with engine input and output mode control
  GFCP_PortBindingService(soap_mode imode, soap_mode omode);
  /// Destructor, also frees all deserialized data
  virtual ~GFCP_PortBindingService();
  /// Delete all deserialized data (uses soap_destroy and soap_end)
  virtual	void destroy();
  /// Initializer used by constructor
  virtual	void GFCP_PortBindingService_init(soap_mode imode, soap_mode omode);
  /// Create a copy
  virtual	GFCP_PortBindingService *copy();
  /// Force close connection (normally automatic)
  virtual	int soap_close_socket();
  /// Return sender-related fault to sender
  virtual	int soap_senderfault(const char *string, const char *detailXML);
  /// Return sender-related fault with SOAP 1.2 subcode to sender
  virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
  /// Return receiver-related fault to sender
  virtual	int soap_receiverfault(const char *string, const char *detailXML);
  /// Return receiver-related fault with SOAP 1.2 subcode to sender
  virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
  /// Print fault
  virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
  /// Print fault to stream
  virtual	void soap_stream_fault(std::ostream&);
  /// Put fault into buffer
  virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
  /// Disables and removes SOAP Header from message
  virtual	void soap_noheader();
  /// Run simple single-thread iterative service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
  virtual	int run(int port);
  /// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
  virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
  /// Accept next request (returns socket or SOAP_INVALID_SOCKET)
  virtual	SOAP_SOCKET accept();
  /// Serve this request (returns error code or SOAP_OK)
  virtual	int serve();
  /// Used by serve() to dispatch a request (returns error code or SOAP_OK)
  virtual	int dispatch();

  ///
  /// Service operations (you should define these):
  ///

  /// Web service operation 'queryRequest' (returns error code or SOAP_OK)
  virtual	int queryRequest(ns1__dataRequest *ns1__queryRequest, ns1__dataResponse *ns1__queryResponse);

  /// Web service operation 'controlRequest' (returns error code or SOAP_OK)
  virtual	int controlRequest(ns1__dataRequest *ns1__controlRequest, ns1__basicResponse *ns1__controlResponse);

  /// Web service operation 'frameRequest' (returns error code or SOAP_OK)
  virtual	int frameRequest(ns1__dataRequest *ns1__frameRequest, ns1__basicResponse *ns1__frameResponse);

  /// Web service operation 'notificationRequest' (returns error code or SOAP_OK)
  virtual	int notificationRequest(ns1__dataRequest *ns1__notificationRequest, ns1__basicResponse *ns1__notificationResponse);

  /// Web service operation 'extensionRequest' (returns error code or SOAP_OK)
  virtual	int extensionRequest(ns1__dataRequest *ns1__extensionRequest, ns1__dataResponse *ns1__extensionResponse);

  ///
  /// /////////    Manually Added     /////////
  ///

  void stop();

  void setXMLHandler(XML_Handler* xmlHandler);

  //        void setClientSOAP(GFCP_WS_Client *clientSOAP);

private:
  XML_Handler* xmlHanlder;
  //        GFCP_WS_Client *clientSOAP;
  bool isKeepRunning;

};
#endif
