/****************************************************************************
 *
 * File Name: Action.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/
#ifndef ACTION_H
#define ACTION_H

/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include <string.h>
#include "../Includes/Datastructures.h"
#include "../Includes/Common.h"

#include "Auxiliary.h"

/**
 * \brief Action class.
 */
class Action
{
public:

  friend std::ostream& operator<<(std::ostream& out, const Action& act)
  {
    act.printAction(out);
    return out;
  }

  friend std::ostream& operator<<(std::ostream& out, const Action* act)
  {
    act->printAction(out);
    return out;
  }

  Action()
  {
  }
  virtual ~Action()
  {
  }
  virtual void printAction(std::ostream&) const=0;
  virtual std::string performAction(Frame *frm)
  {
    return "Performing Default Action.\n";
  }
  ;
  virtual Action* clone() = 0;
};

#endif /* ACTION_H */
