/****************************************************************************
 *
 * File Name: Action_Add.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/
#ifndef ACTION_ADD_H
#define ACTION_ADD_H
/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Add.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action.h"

/**
 * \brief Action Add class.
 */
class Action_Add : public Action
{
public:
  Action_Add();
  Action_Add(unsigned int offset, unsigned int length);
  Action_Add(const Action_Add &other);
  virtual ~Action_Add();
  void printAction(std::ostream&) const;
  std::string performAction(Frame *frm);
  Action* clone()
  {
    return new Action_Add(*this);
  }

protected:
  Position position;
};

#endif /* ACTION_ADD_H */
