/****************************************************************************
 *
 * File Name: Action_Assign.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/
#ifndef ACTION_ASSIGN_H
#define ACTION_ASSIGN_H
/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Assign.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action.h"

/**
 * \brief Action Assign class.
 */
class Action_Assign : public Action
{
public:
  Action_Assign();
  Action_Assign(unsigned int offset, unsigned int length, BYTE *_value);
  Action_Assign(unsigned int offset, unsigned int length, BYTE *_value, unsigned int firstBitOffset,
                unsigned int lastBitOffset);
  Action_Assign(unsigned int offset, unsigned int length, BYTE *_value, unsigned int chksumOffset,
                unsigned int chksumLength, bool _isPerformAction);
  Action_Assign(unsigned int offset, unsigned int length, BYTE *_value, unsigned int chksumOffset,
                unsigned int chksumLength, bool _isPerformAction, unsigned int firstBitOffset,
                unsigned int lastBitOffset);
  Action_Assign(const Position _pos, BYTE *_value, unsigned int chksumOffset, unsigned int chksumLength,
                bool _isPerformAction);
  Action_Assign(const Position _pos, BYTE *_value);

  Action_Assign(const Action_Assign & other);
  virtual ~Action_Assign();
  void printAction(std::ostream&) const;
  std::string performAction(Frame *frm);
  Action* clone()
  {
    return new Action_Assign(*this);
  }

protected:
  Position position;
  BYTE *value;
  bool isAffectingChksum;
  Position chksumPosition;
  bool isPerformAction;
};

#endif /* ACTION_ASSIGN_H */
