/****************************************************************************
 *
 * File Name: Action_Copy.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef ACTION_COPY_H
#define ACTION_COPY_H

/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Copy.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action.h"

/**
 * \brief Action Copy class.
 */
class Action_Copy : public Action
{
public:
  Action_Copy();
  Action_Copy(unsigned int dstOffset, unsigned int srcOffset, unsigned int length);
  Action_Copy(unsigned int dstOffset, unsigned int srcOffset, unsigned int length, unsigned int chksumOffset,
              unsigned int chksumLength, bool _isPerformAction);
  Action_Copy(const Action_Copy & other);
  Action_Copy(const Position _srcPos, const Position _dstPos, unsigned int chksumOffset, unsigned int chksumLength,
              bool _isPerformAction);
  Action_Copy(const Position _srcPos, const Position _dstPos);
  virtual ~Action_Copy();
  void printAction(std::ostream&) const;
  std::string performAction(Frame *frm);

  Action* clone()
  {
    return new Action_Copy(*this);
  }

protected:
  Position positionSrc;
  Position positionDst;
  bool isAffectingChksum;
  Position chksumPosition;
  bool isPerformAction;
};

#endif /* ACTION_COPY_H */
