/****************************************************************************
 *
 * File Name: Action_Cut.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef ACTION_CUT_H
#define ACTION_CUT_H

/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Cut.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action.h"

/**
 * \brief Action Cut class.
 */
class Action_Cut : public Action
{
public:
  Action_Cut();
  Action_Cut(unsigned int offset, unsigned int length);
  Action_Cut(const Action_Cut &other);
  virtual ~Action_Cut();
  void printAction(std::ostream&) const;
  std::string performAction(Frame *frm);
  Action* clone()
  {
    return new Action_Cut(*this);
  }

protected:
  Position position;
};

#endif /* ACTION_CUT_H */
