/****************************************************************************
 *
 * File Name: Action_Forward.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 16/04/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef ACTION_FORWARD_H_
#define ACTION_FORWARD_H_

/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Forward.h
 *\brief A brief description of the file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action.h"

/**
 * \brief Action Forward class.
 */
class Action_Forward : public Action
{
public:
  Action_Forward();
  Action_Forward(unsigned int _PortID, double _qos);
  Action_Forward(const Action_Forward &other);
  virtual ~Action_Forward();
  void printAction(std::ostream&) const;
  std::string performAction(Frame *frm);
  Action* clone()
  {
    return new Action_Forward(*this);
  }

protected:
  unsigned int PortID;
  double qos;
};

#endif /* ACTION_FORWARD_H_ */
