/****************************************************************************
 *
 * File Name: Action_Table.h
 *
 * General Description: Defines the Actions Table.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/
#ifndef ACTION_TABLE_H
#define ACTION_TABLE_H
/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file Action_Table.h
 *\brief Defines the Actions Table.
 *
 * This table stores the (FWD_KEYs, Actions) pairs.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "Action_Assign.h"
#include "Action_Copy.h"
#include "Action_Cut.h"
#include "Action_Arithmetic.h"
#include "Action_Add.h"
#include "Action_Forward.h"
#include "FWD_KEY.h"
#include "../Includes/Common.h"

/**
 * \brief Action Table class.
 */
class Action_Table
{
public:
  Action_Table()
  {
  }
  ;
  virtual ~Action_Table()
  {
  }
  ;
  virtual std::string addNewEntry(unsigned int interface, std::vector<fwdKeyMaskpair *> &fwdKeyMaskVect, std::vector<Action*> &actions)=0;
  virtual std::string removeEntry(unsigned int interface, std::vector<fwdKeyMaskpair *> &fwdKeyMaskVect)=0;
  virtual void getActions(std::vector<fwdKeyMaskpair *> &fwdKeyMaskVect,
                          std::vector<std::vector<Action*> > &actionsVect)=0;
  virtual void printTable()=0;
};

#endif /* ACTION_TABLE_H */
