/****************************************************************************
 *
 * File Name: Auxiliary.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 14/04/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef AUXILIARY_H_
#define AUXILIARY_H_

/****************************************************************************
 * File description
 ****************************************************************************/

/*! \file Auxiliary.h
 *\brief Auxiliary header file.
 *
 * Auxiliary functions namespace.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include <string>
#include <iomanip>
#include <iostream>
#include <stdint.h>

class Frame;

namespace Auxiliary
{
void printBYTEarray(unsigned char *value, unsigned int length);
void printFrame(bool isBefore, Frame *frm);
int getch();
uint16_t calcUpdatedChecksum(uint16_t oldChecksum, const uint16_t *oldValue, const uint16_t *newValue,
                             unsigned int valueLength);
void zeroBits(unsigned char *byte, unsigned char fitstBitOffset, unsigned char lastBitOffset, bool isShiftBits,
              bool isZeroValue);
}

#endif /* AUXILIARY_H_ */
