/****************************************************************************
 *
 * File Name: ID_KEY.h
 *
 * General Description: General description of the file.
 *
 * Created By: Alex Creation Date: 05/04/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef ID_KEY_H_
#define ID_KEY_H_

/****************************************************************************
 * File description
 ****************************************************************************/

/*! \file ID_KEY.h
 *\brief ID_KEY header file.
 *
 * Full description of the file.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include <string.h>
#include "../Includes/Datastructures.h"
#include "Auxiliary.h"

/**
 * \brief ID_KEY class.
 */
class ID_KEY
{

  friend std::size_t hash_value(const ID_KEY &key);
  friend std::ostream& operator<<(std::ostream& output, const ID_KEY &key);
  friend std::ostream& operator<<(std::ostream& output, const ID_KEY *key);

public:
  ID_KEY();
  ID_KEY(unsigned int _offset, unsigned int _length, std::string _name);
  ID_KEY(unsigned int _offset, unsigned int _length, std::string _name, unsigned char *_value);
  ID_KEY(const ID_KEY & other);
  ID_KEY(const Position &_pos, std::string _name);
  ID_KEY(const Position &_pos, std::string _name, unsigned char *_value);
  virtual ~ID_KEY();
  bool operator ==(const ID_KEY & other) const;
  unsigned int getLength() const;
  std::string getName() const;
  unsigned int getOffset() const;
  unsigned char *getValue() const;
  void setValue(unsigned char *_value);
  Position &getPosition();
  void setPosition(const Position &_pos);

  static void setID_KEYvalue(ID_KEY &key, unsigned char *_value, bool isZeroBits);

protected:
  Position pos;
  std::string name;
  unsigned char *value;
};

#endif /* ID_KEY_H_ */
