/****************************************************************************
 *
 * File Name: ID_to_FWD_Table.h
 *
 * General Description: Defines the Ident to Forward Table.
 *
 * Created By: Alex Creation Date: 01/01/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/
#ifndef ID_TO_FWD_TABLE_H
#define ID_TO_FWD_TABLE_H
/****************************************************************************
 * File description
 ****************************************************************************/
/*! \file ID_to_FWD_Table.h
 *\brief Defines the Ident to Forward Table.
 *
 * Defines the Ident to Forward Table. This table stores the (ID_KEYs,FWD_KEYs)
 * pairs.
 *
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "ID_KEY.h"
#include "FWD_KEY.h"

typedef std::pair<unsigned int, std::vector<ID_KEY *> > portIDvectPair;

/**
 * \brief ID to FWD Table class.
 */
class ID_to_FWD_Table
{
public:
  ID_to_FWD_Table()
  {
  }
  ;
  virtual ~ID_to_FWD_Table()
  {
  }
  ;
  virtual std::string addNewEntry(unsigned int PortID, std::vector<ID_KEY *> &idKeys,
                                  std::vector<fwdKeyMaskpair *> &fwdKeysAndMasks)=0;
  virtual std::string removeEntry(unsigned int PortID, std::vector<ID_KEY *> &idKeys)=0;
  virtual void getFWD_KEYs(unsigned int PortID, std::vector<ID_KEY *> &idKeys,
                           std::vector<fwdKeyMaskpair *> &fwdKeysVect)=0;
  virtual void printTable()=0;
};

#endif /* ID_TO_FWD_TABLE_H */
