/****************************************************************************
 *
 * File Name: NetworkDriverException.h
 *
 * General Description: Contains the NetworkDriver exception.
 *
 * Created By: Alex, Creation Date: 01/04/2011
 *
 * Revisions And Updates:
 *
 * Date		  Updated By		Description
 * ========== ================ =========================
 *
 ****************************************************************************/

#ifndef NETWORKDRIVEREXCEPTION_H_
#define NETWORKDRIVEREXCEPTION_H_

/****************************************************************************
 * File description
 ****************************************************************************/

/*! \file NetworkDriverException.h
 *\brief Contains the NetworkDriver exception.
 *\author Alex
 */

/****************************************************************************
 * Include header files
 ****************************************************************************/

#include <string>

/**
 * \brief NetworkDriverException class.
 */
class NetworkDriverException
{
public:

  NetworkDriverException(std::string msg)
  {
    message = msg;
  }
  ;

  inline std::string getMessage()
  {
    return message;
  }
  ;

  virtual ~NetworkDriverException()
  {
  }
  ;

private:
  std::string message;
};

#endif /* NETWORKDRIVEREXCEPTION_H_ */
