/****************************************************************************
 *
 * File Name: Mapper_Handler.h
 *
 * General Description: Mapper_Handler header file.
 *
 * Created By: Alex Creation Date: 11/09/2011
 *
 * Revisions And Updates:
 *
 * Date 		 Updated By 	  Description
 * ========== ================ =========================
 *
 *
 ****************************************************************************/

#ifndef MAPPER_HANDLER_H_
#define MAPPER_HANDLER_H_

/****************************************************************************
 * File description
 ****************************************************************************/

/*! \file Mapper_Handler.h
 *\brief Mapper_Handler header file.
 *
 * Parses the Mapper LFB file.
 *
 *\author Alex
 */

class XML_Handler;

/****************************************************************************
 * Include header files
 ****************************************************************************/
#include "RapidXML/rapidxml.hpp"
//#include "RapidXML/rapidxml_iterators.hpp"
#include "RapidXML/rapidxml_print.hpp"
#include "RapidXML/rapidxml_utils.hpp"

class Mapper_Handler
{
public:
  Mapper_Handler(XML_Handler *_xmlHandler);
  virtual ~Mapper_Handler();

  std::string parse(std::vector<char> &XML);
  std::string parseFromNode(rapidxml::xml_node<>* cur_node);

private:
  bool frame_mapping_entry_has_all_attr(rapidxml::xml_node<>* frame_mapping);
  bool incoming_field_entry_has_all_attr(rapidxml::xml_node<>* fields_node);
  bool outgoing_field_entry_has_all_attr(rapidxml::xml_node<>* fields_node);
  XML_Handler *xmlHandler;
};

#endif /* MAPPER_HANDLER_H_ */
